package com.virtual.plat.server.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.virtual.plat.server.ServerUtils;
import java.io.Serializable;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.Table;
import javax.xml.bind.JAXB;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import org.apache.commons.lang.StringUtils;
import org.hibernate.annotations.AccessType;

@Entity
@AccessType("field")
@Table(
   name = "TBL_PUBLIC_CLOUD"
)
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType
public class PublicCloud implements Serializable {

   public static final int ALI = 1;
   public static final int CVM = 2;
   public static final int VMWARE = 3;
   public static final int CIC = 4;
   public static final int CLOUDOS = 5;
   private static final long serialVersionUID = 3779199466720743755L;
   @Id
   @Column(
      name = "ID"
   )
   @GeneratedValue(
      strategy = GenerationType.IDENTITY
   )
   @XmlAttribute
   private Long id = null;
   @Column(
      name = "NAME"
   )
   private String name;
   @Column(
      name = "DESCRIPTION"
   )
   private String description;
   @Column(
      name = "FLAG"
   )
   private Integer flag;
   @Column(
      name = "URI"
   )
   private String uri;
   @Column(
      name = "USER_NAME"
   )
   private String userName;
   @Column(
      name = "PASSWORD"
   )
   private String password;
   @Column(
      name = "PROTOCAL"
   )
   private String protocal = null;
   @Column(
      name = "PORT"
   )
   private Integer port = null;
   @Column(
      name = "TENANT_ID"
   )
   private String tenantId;
   @Column(
      name = "OP_GROUP_ID",
      updatable = false
   )
   @XmlTransient
   private Long opGroupId;
   @Column(
      name = "OP_GROUP_CODE",
      updatable = false
   )
   @XmlTransient
   private String opGroupCode;
   @ManyToMany(
      mappedBy = "publicClouds"
   )
   @XmlTransient
   @JsonIgnore
   private Set aclStrategys = null;


   public String getConnectUri() {
      StringBuilder var1 = new StringBuilder();
      if(this.flag.intValue() == 3) {
         var1.append(this.protocal).append("://");
         var1.append(this.uri);
         var1.append(":").append(this.port);
         var1.append("/sdk");
      } else {
         var1.append(this.uri);
      }

      return var1.toString();
   }

   public Long getId() {
      return this.id;
   }

   public void setId(Long var1) {
      this.id = var1;
   }

   public String getName() {
      return this.name;
   }

   public void setName(String var1) {
      this.name = var1;
   }

   public String getDescription() {
      return this.description;
   }

   public void setDescription(String var1) {
      this.description = var1;
   }

   public Integer getFlag() {
      return this.flag;
   }

   public void setFlag(Integer var1) {
      this.flag = var1;
   }

   public String getUri() {
      return this.uri;
   }

   public void setUri(String var1) {
      this.uri = var1;
   }

   public String getUserName() {
      return this.userName;
   }

   public void setUserName(String var1) {
      this.userName = var1;
   }

   public String getPassword() {
      return !StringUtils.isEmpty(this.password)?ServerUtils.decryptText(this.password):null;
   }

   public void setPassword(String var1) {
      this.password = !StringUtils.isEmpty(var1)?ServerUtils.encryptText(var1):null;
   }

   public static long getSerialversionuid() {
      return 3779199466720743755L;
   }

   public String getProtocal() {
      return this.protocal;
   }

   public void setProtocal(String var1) {
      this.protocal = var1;
   }

   public Integer getPort() {
      return this.port;
   }

   public void setPort(Integer var1) {
      this.port = var1;
   }

   @Column(
      updatable = false
   )
   public Long getOpGroupId() {
      return this.opGroupId;
   }

   public void setOpGroupId(Long var1) {
      this.opGroupId = var1;
   }

   @Column(
      updatable = false
   )
   public String getOpGroupCode() {
      return this.opGroupCode;
   }

   public void setOpGroupCode(String var1) {
      this.opGroupCode = var1;
   }

   public String getTenantId() {
      return this.tenantId;
   }

   public void setTenantId(String var1) {
      this.tenantId = var1;
   }

   public Set getAclStrategys() {
      return this.aclStrategys;
   }

   public void setAclStrategys(Set var1) {
      this.aclStrategys = var1;
   }

   public static void main(String[] var0) {
      PublicCloud var1;
      (var1 = new PublicCloud()).setDescription("desc");
      var1.setFlag(Integer.valueOf(4));
      var1.setId(Long.valueOf(12L));
      var1.setName("cvm2");
      var1.setOpGroupCode("00");
      var1.setOpGroupId(Long.valueOf(20L));
      var1.setPassword("passwoprd");
      var1.setPort(Integer.valueOf(8080));
      var1.setProtocal("http");
      var1.setUri("uri");
      var1.setUserName("admin");
      JAXB.marshal(var1, System.out);
   }

   public boolean isCloudResSupported() {
      return this.flag.intValue() == 2 || this.flag.intValue() == 3 || this.flag.intValue() == 5;
   }
}
